////////////////////////////////////////////////////////////
// I2C LCD Cu@PIC18  Ver 2.0 20130512
//  Xgx[ibNXt\Cu
//  ȉ̋@\
//    LCD_int()     ----- 
//    LCD_cmd(cmd)  ----- R}ho
//    LCD_dat(chr)  ----- P\
//    LCD_str(*str) ---- \
//    LCD_ROMstr(*str) -- ROM\
//    LCD_hex(char); 
//    LCD_posyx(y,x) ---- J[\ʒuwAs yAʒu x
//    LCD_clr()      ----- S
//    LCD_icon_on(icn);--- wACRON
//    LCD_icon_off(icn);-- wACROFF
//    LCD_icon_clrf();---- SACROFF
//t\PICI2Cɂڑ
//     1)Define I/O PORT
//         PORTB(4)pin13    :  SDA
//         PORTB(6)pin11    :  SCL
//     2)OSC
//         NbN@4MHz 
//
// Copyright (c) 2012-2013 iwamoto All Rights Reserved
////////////////////////////////////////////////////////////

#include <xc.h>
#include "L_i2cLCD.h"

void _EEByteWrite(char, char, char);
void _i2cTx(char);

void _EEByteWrite(char addr, char cont, char data){
	SSPCON2bits.SEN = 1;         // Start condition Jn
	while(SSPCON2bits.SEN);     // Start condition 
	_i2cTx(addr);
	_i2cTx(cont);
	_i2cTx(data);
	PIR1bits.SSPIF = 0;
	SSPCON2bits.PEN = 1;
	while(SSPCON2bits.PEN);	
}

void _i2cTx(char data){
	PIR1bits.SSPIF = 0;
	SSPBUF = data;
	while(!PIR1bits.SSPIF);
}

//-------- P\
void LCD_dat(char chr){
	_EEByteWrite(0x7C, 0x40, chr);
	Delay_50uS;		// 50sec
}
//-------- R}ho
void LCD_cmd(char cmd){
	_EEByteWrite(0x7C, 0x00, cmd);
	if(cmd & 0xFC)   // ʂUrbgɂP閽
		Delay_50uS;  // 50usec
	else
		Delay_2mS;   // 2msec@ClearHomeR}h
}
//-------- S
void LCD_clr(void){
	LCD_cmd(0x01);		//ClearR}ho
}
//-------- J[\ʒuw
void LCD_posyx(char ypos, char xpos){
	unsigned char pcode;
	switch(ypos & 0x03){	
		case 0:	pcode=0x80;break;
		case 1:	pcode=0xC0;break;
		case 2:	pcode=0x94;break;
		case 3:	pcode=0xD4;break;
	}
	LCD_cmd(pcode += xpos);
}
//-------- o
void LCD_str(char *str){
	while(*str)			//̏I(00)܂Ōp
		LCD_dat(*str++);	//o͂|C^{P
}
//-------- Rom o
void LCD_ROMstr(const char *str){
	while(*str)			//̏I(00)܂Ōp
		LCD_dat(*str++);	//o͂|C^{P
}
//-------- PUiϊ\
void LCD_hex(char c){
    const char hexch[] ="0123456789ABCDEF";
    LCD_dat(hexch[c >> 4]);
    LCD_dat(hexch[c & 0xF]);
}

//-------- 
void LCD_int(void){
    SSPCON1 = 0x28;       //I2C}X^[[hw
    SSPSTAT = 0x00;
    SSPADD = BaudConst;              //Board Rate 
	Delay_100mS;
	LCD_cmd(0x38);		// 8bit 2s \߃[h
	LCD_cmd(0x39);		// 8bit 2s g߃[h
	LCD_cmd(0x14);		// OSC  BIAS ݒ1/5
						// RgXgݒ 
	LCD_cmd(0x70 + (CONTRAST & 0x0F));
	LCD_cmd(0x54 + (CONTRAST >> 4));
	LCD_cmd(0x6B);		// Ffollwer
	Delay_100mS;
	Delay_100mS;
	LCD_cmd(0x38);		// \߃[h 
	LCD_cmd(0x0C);		// Display On 
	LCD_cmd(0x01);		// Clear Display 
}
//-- wACR ON
void LCD_icon_on(int icn){
	LCD_cmd(0x39);			// g߃[h 
	LCD_cmd(icn >> 8);		// Icon AhX 
	LCD_dat(icn & 0xFF);	// Icon rbg <ON>
	LCD_cmd(0x38);			// \߃[h 
}
//-- wACR OFF
void LCD_icon_off(int icn){
	LCD_cmd(0x39);			// g߃[h 
	LCD_cmd(icn >> 8);		// Icon AhX 
	LCD_dat(0x00);			// Icon rbg <OFF>
	LCD_cmd(0x38);			// \߃[h 
}
//-- SACR OFF
void LCD_icon_clr(void){
	unsigned char icn = 0x40;
	LCD_cmd(0x39);			// g߃[h 
	while(icn <= 0x4F){
		LCD_cmd(icn++);		// Icon AhX 
		LCD_dat(0x00);		// Icon rbg <OFF>
	}
	LCD_cmd(0x38);			// \߃[h 
}

